
// c++ Note: The ifndef, this is useless for python but can become usefull if the extension becomes a lot bigger. 
// c++ Note: This basically prevents the header from being compiled more than once if its used in multiple area's of a project. 
// c++ Note: If (if) this word is not(n) defined (def)
#ifndef PYTHONEXTENSIONS_RINGRING_H
// c++ Note: define the this word. 
#define PYTHONEXTENSIONS_RINGRING_H


// Name spaces are a good habit to get into as it makes it easier to extend your project. 
// Also makes your code more readable. 
// Note that opinions differ on this. Do a search on stack overflow to give you months of reading material on namespaces haha. 
namespace PythonExtensions { 

	// So here we define a class called PythonCalls 
	class PythonCalls
	{
		// It has the following public members 
	public:

		bool valid; // Valid boolean to keep track if the class is still valid to be called from python. 
		
		// The first function here is the constructor. This gets called when the class is initialized. like a python __init__ 
		PythonCalls();
		// This is a deconstructor. it is the same name as the class but with a tilde ~ infront of it. 
		// This is called when the class is deleted. 
		~PythonCalls(); 


		// Lets create a double pointer pointer to use as an example of passing arguments around. 
		/* 
			A double pointer pointer can be SEEN as an list of lists in python. 
			Its basically a list of pointers to other pointers. 
					
		*/		
		double ** array2D; 
		// We need the info of the array because in c++ we can not query how big an array of pointers is. 
		// So we just store the information as a member. (in python you can see this as self.rows and self.columns etc) 
		int rows; // This will hold the info on how manny rows the array has 
		int columns; // This will hold the info on how manny collumns the array has. 


		// As you can see all functions return something. Even though most functions do not need to. 
		// However there seems to be a problem in release mode where python starts garbage collecting the class object.
		// So returning a value prevents that from happening. 
		int CreateArray( double ** pythonArray,int rows, int columns);
		int CreateArray( int rows, int columns); 
		int PrintArray( );
		int SmoothArray(int percentage); // Percentage is in 0 to 100 
		bool IsValid(); // just an example of a simple return boolean
		double ** GetArray(); // actually getting the array back again but the actual pointer. 
		double ** GetArrayCopy(); // actually getting the array back again but this time a copy. 

	private:

	};



}
// Here we end our if. So the compiler knows where to end.
#endif